.nolist
include \masm32\include\masm32rt.inc

.686
.xmm
include \masm32\macros\timers.asm			
LOOP_COUNT	= 10000


 l_htodw	PROTO : DWORD
 l_a2l       proto :dword 
Axhex2dw  PROTO : DWORD
Axa2l   proto :dword 
Axa2l_ex proto :dword

StrCmpSSE	PROTO: DWORD, :DWORD



.data

align  16
hexstring    db  "AbCdEf01",0

align 16
numstring          db  "1234543210",0
align 16
negnumstring   db  "-1234543210",0

.code
start:
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@

	REPEAT 1

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_htodw, addr  hexstring
    counter_end
	     print str$(eax), 9, "cycles for  l_htodw Lingo", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axhex2dw, addr  hexstring
    counter_end
	    print str$(eax), 9, "cycles for Axhex2dw", 13, 10


	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_a2l , addr  numstring 
    counter_end
	     print str$(eax), 9, "cycles for  l_a2l  Lingo", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axa2l , addr  numstring 
    counter_end
	     print str$(eax), 9, "cycles for  Axa2l", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axa2l_ex , addr  numstring 
    counter_end
	     print str$(eax), 9, "cycles for  Axa2l_ex", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke l_a2l , addr  negnumstring 
    counter_end
	     print str$(eax), 9, "cycles for  l_a2l  Lingo - negative", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axa2l , addr  negnumstring 
    counter_end
	     print str$(eax), 9, "cycles for  Axa2l - negative ", 13, 10

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	
		invoke Axa2l_ex , addr  negnumstring 
    counter_end
	     print str$(eax), 9, "cycles for  Axa2l_ex - negative ", 13, 10

		 
	
	ENDM

	print " ", 13, 10
	print "Codesizes:", 13, 10
	print "l_htodw-Lingo:", 9
	mov   eax, l_htodw_endp
	sub	  eax, l_htodw
	print str$(eax), 13, 10

	print "Axhex2dw:", 9
	mov   eax, Axhex2dw_endp
	sub	  eax, Axhex2dw
	print str$(eax), 13, 10

	print "l_a2 - Lingo:", 9
	mov   eax, l_a2l_endp
	sub	  eax, l_a2l
	print str$(eax), 13, 10

	print "Axa2l:", 9,9
	mov   eax, Axa2l_endp
	sub	  eax, Axa2l
	print str$(eax), 13, 10

	print "Axa2l_ex:", 9
	mov   eax, Axa2l_ex_endp
	sub	  eax, Axa2l_ex
	print str$(eax), 13, 10
	inkey "--- ok ---"
	exit


push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp



option prologue:none
option epilogue:none	
align 16
db 0,0,0,0,0,0,0,0,0,0,0,0,0
l_htodw   proc lpString:dword
	mov		edx, [esp+4]
	mov     ecx,  11011111Y
	mov		[esp+4], ebx
	xor		 eax, eax
	and      ecx, [edx]
    je         @f   +1Eh
@@:
     lea      ebx, [ecx-19h]
     inc      edx
  	 add     ecx, -40h
     lea      eax, [eax*8]
	 cmovb   ebx, ecx
 	 mov    ecx,11011111Y
	 lea      eax, [eax*2+ebx+9]
     and     ecx, [edx]
     jnz      @b 
     pop     ecx
	 pop		ebx
	 jmp		ecx
l_htodw  endp
l_htodw_endp:

align 16
Axhex2dw    proc STDCALL lpszStr:DWORD

   push edi
    mov edi,[esp+8]
    mov eax,0

    @@:
    movzx edx,byte ptr [edi]
    ;movzx ecx,byte ptr [edi]
    mov ecx,edx
    cmp edx,0
    jz @done1
    shr ecx,6
    and ecx,1
    add edi,1
    add edx,ecx
    shl eax,4h
    lea edx,[edx-30h+ecx*8]
    and edx,0fh
    add eax,edx
    jmp @B
   
    @done1:
    ;pop ebp
    pop edi
    ret 4

    push edi
    mov edi,[esp+8]
    xor ecx,ecx
    mov eax,0		; if you have use only full-notated hex numbers, then comment this mnemonic,
    @@:			; i.e, if you use numbers like 00000007, but not 07 or simple 7,
    movzx edx,byte ptr [edi]	; if you use short notation (07 or 7), then eax must be zeroed (mov eax,0 instead
    cmp edx,0			; xor eax,eax used, because it slightly faster, and align loop to 4 bytes).
    jz @done
    test dl,1000000Y
    setne cl
    add edx,ecx
    add edi,1
    shl eax,4h
    lea edx,[edx-30h+ecx*8]
    and edx,0fh
    add eax,edx
    jmp @B

    @done:
    pop edi
    ret 4
Axhex2dw    endp
Axhex2dw_endp:




align 16
db 0, 0, 0, 0 
l_a2l proc lpString:dword
	mov		edx, [esp+1*4]		
	mov		ecx, 11111111Y
	mov		[esp+1*4], ebx		
	movzx eax, byte ptr [edx]
	cmp     eax,'-'
	lea		eax, [eax-30h]
    jz         negative
	and      ecx, [edx+1]
	jz			@f

	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx,  ebx
	and      ebx, [edx+2]
	jz			@f

	and      ecx, [edx+3]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f

	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx, ebx
	and      ebx, [edx+4]
	jz			@f

	and      ecx, [edx+5]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f

	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx,  ebx
	and      ebx, [edx+6]
	jz			@f

	and      ecx, [edx+7]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f
	
	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx,  ebx
	and      ebx, [edx+8]
	jz			@f

	and      ecx, [edx+9]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
@@:
	pop		ecx
	pop		ebx
	jmp		ecx
align 16
negative:
	xor		eax,  eax	
	mov		ebx, 11111111Y
	and      ecx, [edx+1]
	jz			@f

	and      ebx, [edx+2]
	mov		ecx, 11111111Y
	lea		eax, [ecx-30h]
	jz			@f

	and      ecx, [edx+3]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f

	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx, ebx
	and      ebx, [edx+4]
	jz			@f

	and      ecx, [edx+5]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f

	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx,  ebx
	and      ebx, [edx+6]
	jz			@f

	and      ecx, [edx+7]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f
	
	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	mov		ecx, ebx
	and      ebx, [edx+8]
	jz			@f

	and      ecx, [edx+9]
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
	jz			@f

	mov		ebx, 11111111Y
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ecx-30h]
	and      ebx, [edx+10]
	jz			@f
	lea       eax, [eax+eax*4]
	lea		eax, [eax*2+ebx-30h]
@@:
    sub     eax,  1
    xor      eax,-1
	pop		ecx
	pop		ebx
	jmp		ecx
l_a2l		endp
l_a2l_endp:

align 16
Axa2l proc lpszString:DWORD
    pop ecx
    pop edx
    push ecx
    push edi
    xor edi,edi
        xor eax,eax
        movzx ecx,byte ptr [edx]
        cmp cl,'-'
        jnz @preloop
        inc edx
        dec edi
@mainloop:
        mov cl, byte ptr [edx]
@preloop:
        jecxz @done
        lea eax,[eax+eax*4]
        inc edx
        lea eax,[eax*2+ecx-'0']
        jmp @mainloop
 @done:        
    add eax,edi
    xor eax,edi
    pop edi
    ret
Axa2l endp
Axa2l_endp:


align 16
Axa2l_ex proc lpszString:DWORD

    mov edx,[esp+4]

    push edi

    xor edi,edi

        xor eax,eax
        movzx ecx,byte ptr [edx]
        cmp cl,'-'
        jnz @preloop
        inc edx
        dec edi

        movzx ecx, byte ptr [edx]
	@preloop:
        
        jecxz @done
        lea eax,[ecx-'0']

        movzx ecx, byte ptr [edx+1]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']
 
        movzx ecx, byte ptr [edx+2]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+3]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+4]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+5]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+6]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+7]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+8]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

        movzx ecx, byte ptr [edx+9]
        jecxz @done
        lea eax,[eax+eax*4]
        lea eax,[eax*2+ecx-'0']

    @done:        


    add eax,edi
    xor eax,edi

    pop edi

    ret 4

Axa2l_ex endp
Axa2l_ex_endp:


option prologue:prologuedef
option epilogue:epiloguedef

end start

